package org.vtokarev.controller;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.vtokarev.domain.RoomClass;
import org.vtokarev.dto.RoomSearchDto;
import org.vtokarev.service.RoomClassService;
import org.vtokarev.service.RoomService;
import org.vtokarev.tuples.Pair;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.time.LocalDate;
import java.time.format.DateTimeParseException;
import java.util.List;
import java.util.stream.IntStream;

/**
 * {@code SearchRoomServlet} class uses for search room functionality for GUEST and MANAGER.
 * It implements {@code doGet} method that processes GET {@code searchRoom} requests generated by users with GUEST and MANAGER roles.
 * In the {@code doGet} method, it collects data, searches the rooms, gets search results set them as an attribute, and forwards them to {@code searchRoomGuest.jsp} view for further processing.
 *
 * @author Vyacheslav Tokarev
 */

@WebServlet(urlPatterns = "/searchRoom", name = "searchRoomServlet")
public class SearchRoomServlet extends HttpServlet {

    protected static final Logger LOGGER = LogManager.getLogger("SearchRoomServlet");

    private RoomClassService roomClassService;

    private RoomService roomService;

    private int recordsPerPage;

    @Override
    public void init(ServletConfig config) throws ServletException {
        roomClassService = (RoomClassService) config.getServletContext().getAttribute("app/RoomClassService");
        roomService = (RoomService) config.getServletContext().getAttribute("app/RoomService");
        recordsPerPage = (int)config.getServletContext().getAttribute("app/searchRoomGuestRecordsPerPage");
    }

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        int[] capacities = IntStream.range(1, roomService.getMaxCapacity() + 1).toArray();
        List<RoomClass> roomClasses = roomClassService.getAll();
        req.setAttribute("capacities", capacities);
        req.setAttribute("roomClasses", roomClasses);

        boolean isSearch = false;
        boolean showOnlyAvailable = true;
        LocalDate checkin = null;
        LocalDate checkout = null;
        Integer personsNumber = null;
        Long roomClassId = null;
        String orderBy = null;


        if (req.getParameter("search") != null) {
            isSearch = true;
            req.setAttribute("search", "yes");
        }

        if (req.getParameter("checkin") != null) {
            try {
                checkin = LocalDate.parse(req.getParameter("checkin"));
                req.setAttribute("checkin", checkin.toString());
            } catch (DateTimeParseException e) {
                checkin = LocalDate.now();
                LOGGER.error("checkin parsing exception", e);
            }
        }
        if (req.getParameter("checkout") != null) {
            try {
                checkout = LocalDate.parse(req.getParameter("checkout"));
                req.setAttribute("checkout", checkout.toString());
            } catch (DateTimeParseException e) {
                checkout = LocalDate.now();
                LOGGER.error("checkout parsing exception", e);
            }
        }

        if (req.getParameter("personsNumber") != null) {
            try {
                personsNumber = Integer.parseInt(req.getParameter("personsNumber"));
                req.setAttribute("personsNumber", personsNumber);
            } catch (NumberFormatException e) {
                LOGGER.error("personsNumber parsing exception", e);
            }
        }

        if (req.getParameter("roomClassId") != null && !"Any".equalsIgnoreCase(req.getParameter("roomClassId"))) {
            try {
                roomClassId = Long.parseLong(req.getParameter("roomClassId"));
                req.setAttribute("roomClassId", roomClassId);
            } catch (NumberFormatException e) {
                LOGGER.error("roomClassId parsing exception", e);
            }
        }

        if ("on".equals(req.getParameter("showOnlyAvailable"))) {
            req.setAttribute("showOnlyAvailable", "on");
        } else {
            req.setAttribute("showOnlyAvailable", "");
            showOnlyAvailable = false;
        }

        if (req.getParameter("orderBy") != null) {
            orderBy = req.getParameter("orderBy");
            req.setAttribute("orderBy", orderBy);
        }

        if (isSearch) {
            int page = Integer.parseInt(req.getParameter("page"));
            int recordCount = roomService.getBookingRoomsCount(checkin, checkout,showOnlyAvailable, roomClassId, personsNumber);
            int pageCount = (int)Math.ceil((double)recordCount / recordsPerPage);
            List<Integer> pages = IntStream.range(1, pageCount + 1).boxed().toList();

            Pair<List<RoomSearchDto>, String> rooms = roomService.getRoomsByParams(checkin, checkout, showOnlyAvailable,
                    roomClassId, personsNumber, orderBy, recordsPerPage, recordsPerPage * (page - 1));
            if ("empty".equals(rooms.getB())) {
                req.setAttribute("errorMessage", "no.rooms.matching.search.criteria.message");
            } else if (!"success".equals(rooms.getB())) {
                req.setAttribute("errorMessage", rooms.getB());
            }
            req.setAttribute("rooms", rooms.getA());
            req.setAttribute("page", page);
            req.setAttribute("recordCount", recordCount);
            req.setAttribute("pages", pages);
        }
        req.getRequestDispatcher("/WEB-INF/jsp/searchRoomGuest.jsp").forward(req, resp);
    }
}